<template>
  <div div="user">
    <b-jumbotron>
      <template slot="header">Group {{ $route.params.groupName }}</template>

      <div>
        <b-alert :show="hasError" dismissible variant="danger">{{ alertMessage }}</b-alert>
      </div>

      <div>Group {{ group.name }}, department of {{ group.department }}</div>
      <div class="mydiv-tablealign">
        <table class="table table-bordered">
          <thead>
            <tr>
              <th>Student Name</th>
              <th>Subjects completed</th>
              <th>Subjects total</th>
            </tr>
          </thead>

          <tr v-for="student in group.students" class="static" v-bind:key="student">
            <td
              @click="dispatchToStudent(group.name, student.name + ' ' + student.surname)"
            >{{student.name + ' ' + student.surname}}</td>
            <td>{{student.passed}}</td>
            <td>{{student.total}}</td>
          </tr>
        </table>
      </div>
    </b-jumbotron>
  </div>
</template>

<script>
import { AXIOS } from "./http-common";

export default {
  data() {
    return {
      group: { name: "??", department: "??", students: [] },
      alertMessage: "Request error",
      hasError: false
    };
  },
  mounted() {
    this.loadItems(this.$route.params.groupName);
  },
  beforeRouteUpdate(to, _, next) {
    this.loadItems(to.params.groupName);
    next();
  },
  methods: {
    dispatchTo(name) {
      this.$router.push({ name: "Group", params: { groupName: name } });
    },
    showAlert(msg) {
      this.hasError = true;
      this.alertMessage = msg;
    },
    dispatchToStudent(group, name) {
      this.$router.push({
        name: "Student",
        params: { groupName: group, studentName: name }
      });
    },
    async loadItems(groupName) {
      let res = await AXIOS.get("/edu/groups/" + groupName, {})
        .then(
          response => {
            console.log(response);
            this.group.name = response.data.name;
            this.group.department = response.data.department;
            this.group.students = [];
            response.data.students.forEach(student => {
              var total = 0;
              var passed = 0;
              for (let key in student.marks) {
                total++;
                if (
                  student.marks[key].composedMark >= 60 &&
                  student.marks[key].attempts > 0
                ) {
                  passed++;
                }
              }
              this.group.students.push({
                name: student.name,
                surname: student.surname,
                total: total,
                passed: passed
              });
            });
            this.hasError = false;
            return this.group;
          },
          error => {
            this.$data.alertMessage =
              error.response.data.length < 150
                ? error.response.data
                : "Request error. Please, report this error website owners";
            this.hasError = true;
            this.group = { name: "??", department: "??", students: [] };
            console.log(error);
          }
        )
        .catch(e => {
          console.log(e);
          this.showAlert(
            "Server error. Please, report this error website owners"
          );
          this.group = { name: "??", department: "??", students: [] };
          this.hasError = true;
        });
      console.log(res);
    }
  }
};
</script>

<style>
.mydiv-tablealign {
  text-align: center;
}
</style>